#pragma once

#include <GameEngine/Config.h>
#include <GameEngine/GameEvent.h>
#include <iostream>

#define REGISTER_EVENT(A_EVENT, A_COMMENT) GameModules::eventRegistry()->registerEvent( #A_EVENT, A_EVENT, A_COMMENT);

///Event Management class
class DLLEXP EventRegistry  {
	friend class GameModules;
	EventRegistry();
public:
	~EventRegistry();

	GameEvent::EventID registerEvent(const char* aEventName, GameEvent::EventID aID, const char* aEventDesc = 0x0);
	GameEvent::EventID getEventID(const char* aEventName) const;
	const char* getEventName(GameEvent::EventID) const;
	const char* getEventDescription(GameEvent::EventID) const;
	void dump(std::ostream*, int a = 0);
	size_t eventCount() const;

private:
	struct PrivateData;
	PrivateData* pData_;
};